#ifndef ISOMORPHISM_H
#define ISOMORPHISM_H

#include <sstream>
#include <iostream>
#include <map>
#include <vector>
#include <string>

#define ISOMORPHISM_CODING_NUMBER_TYPE unsigned long

using namespace std;
using namespace boost;

class Isomorphism { // designed for providing isomorphisms of a given module
private:
	vector<string> pattern; // a pattern contains N strings which corresponds to K unique groups. for example, "[C01,C01,C02,C02,C10,C10]" contains 6 strings and 3 unique groups.
	map<string,vector<int> > group2loc; // a map like "C01->[0,1]; C02->[2,3]; C03->[4,5]"
	vector<dynamic_bitset<> > bits_for_flip_elements; // use xor to flip labels between "A" and "B"
public:
	Isomorphism(vector<string> pattern_);
	void getIsomorphisms(ISOMORPHISM_CODING_NUMBER_TYPE module, vector<ISOMORPHISM_CODING_NUMBER_TYPE>& iso_modules);
	void getPatternOfIsomorphism(ISOMORPHISM_CODING_NUMBER_TYPE module,
		vector<string>& prefix, vector<string>& result_pattern);
	void getPatternOfIsomorphism(ISOMORPHISM_CODING_NUMBER_TYPE module,
		map<int,vector<int> >& chromregion2bead, vector<int>& chrom_regions_module,
		vector<int>& result_pattern);
};

#endif