#ifndef MODULES_H
#define MODULES_H

#include <sstream>
#include <iostream>
#include <map>
#include <vector>
#include <string>

using namespace std;

class Module {
private:
	int module_index; // 1-based index
	vector<int> nodes; // 0-based indexes of nodes
	vector<int> networks; // 0-based indexes of networks
	void read_module_from_file(const char* filename, int which_module, vector<int>& nodes, vector<int>& networks);
public:
	Module(const char* filename, int which_module);
	vector<int>& getNodes() {return nodes;};
	int getNodeNum() {return nodes.size();};
	int getNetworkNum() {return networks.size();};
	vector<int>& getNetworks() {return networks;};
	int getModuleIndex() {return module_index;};
};



#endif